// Beispiel aus: G. Krger, Th. Stark, Handbuch der Javaprogrammierung,
// 5. Auflage, 2007.

import java.io.*;

class Producer extends Thread {
  private PipedOutputStream pipe;

  public Producer(PipedOutputStream pipe) {
    this.pipe = pipe;
  }

  public void run() {
    while (true) {
      byte b = (byte)(Math.random() * 128);
      try {
        pipe.write(b);
        System.out.println("Produzent erzeugte " + b);
      } catch (IOException e) {
        System.err.println(e.toString());
      }
      try {
        Thread.sleep((int)(100*Math.random()));
      } catch (InterruptedException e) {
        //nichts
      }
    }
  }
}

class Consumer extends Thread {
  private PipedInputStream pipe;

  public Consumer(PipedInputStream pipe) {
    this.pipe = pipe;
  }

  public void run() {
    while (true) {
      try {
        byte b = (byte)pipe.read();
        System.out.println(" Konsument fand " + b);
      } catch (IOException e) {
        System.err.println(e.toString());
      }
      try {
        Thread.sleep((int)(100*Math.random()));
      } catch (InterruptedException e) {
        //nichts
      }
    }
  }
}

public class TestProducerConsumer {
  public static void main(String[] args) throws Exception {
    PipedInputStream inPipe = new PipedInputStream();
    PipedOutputStream outPipe = new PipedOutputStream(inPipe);
    Producer p = new Producer(outPipe);
    Consumer c = new Consumer(inPipe);
    p.start();
    c.start();
  }
}
